/* Copyright 2008 Tobias Hunger <tobias.hunger@basyskom.de>
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* This code is generated from the telepathy specification.
 * DO NOT EDIT!
 */

#ifndef QTTELEPATHY_PROPERTIES_INTERFACE_TYPES_GENERATED_H
#define QTTELEPATHY_PROPERTIES_INTERFACE_TYPES_GENERATED_H

#include <QtTelepathy/Common/Common_Export>
#include <QtTelepathy/Common/generic_types>

namespace org {
namespace freedesktop {
namespace Telepathy {

// The following types are not defined inside the current XML file:
//     DBusSignature
//     PropertyID
// You have to make sure that they are either defined in generic-types
// or are typedefs to simple data types!
struct PropertyFlagsChange
{
    quint32 propertyID;
    quint32 newFlags;
};


enum PropertyFlags
{
    PROPERTY_FLAG_READ = 1,
    PROPERTY_FLAG_WRITE = 2,
    PROPERTY_FLAG_MAX = 4
};


struct PropertySpec
{
    quint32 propertyID;
    QString name;
    QString signature;
    PropertyFlags flags;
};



struct PropertyValue
{
    quint32 identifier;
    QDBusVariant value;
};


} // namespace Telepathy
} // namespace freedesktop
} // namespace org

Q_DECLARE_METATYPE(org::freedesktop::Telepathy::PropertySpec)
Q_DECLARE_METATYPE(QList< org::freedesktop::Telepathy::PropertySpec >)
Q_DECLARE_METATYPE(org::freedesktop::Telepathy::PropertyFlagsChange)
Q_DECLARE_METATYPE(QList< org::freedesktop::Telepathy::PropertyFlagsChange >)
Q_DECLARE_METATYPE(org::freedesktop::Telepathy::PropertyValue)
Q_DECLARE_METATYPE(QList< org::freedesktop::Telepathy::PropertyValue >)
Q_DECLARE_METATYPE(org::freedesktop::Telepathy::PropertyFlags)
Q_DECLARE_METATYPE(QList< org::freedesktop::Telepathy::PropertyFlags >)

QTTELEPATHY_COMMON_EXPORT const QDBusArgument & operator >> (const QDBusArgument &, org::freedesktop::Telepathy::PropertySpec &);
QTTELEPATHY_COMMON_EXPORT QDBusArgument & operator << (QDBusArgument &, const org::freedesktop::Telepathy::PropertySpec &);

QTTELEPATHY_COMMON_EXPORT const QDBusArgument & operator >> (const QDBusArgument &, org::freedesktop::Telepathy::PropertyFlagsChange &);
QTTELEPATHY_COMMON_EXPORT QDBusArgument & operator << (QDBusArgument &, const org::freedesktop::Telepathy::PropertyFlagsChange &);

QTTELEPATHY_COMMON_EXPORT const QDBusArgument & operator >> (const QDBusArgument &, org::freedesktop::Telepathy::PropertyValue &);
QTTELEPATHY_COMMON_EXPORT QDBusArgument & operator << (QDBusArgument &, const org::freedesktop::Telepathy::PropertyValue &);

QTTELEPATHY_COMMON_EXPORT const QDBusArgument & operator >> (const QDBusArgument &, org::freedesktop::Telepathy::PropertyFlags &);
QTTELEPATHY_COMMON_EXPORT QDBusArgument & operator << (QDBusArgument &, const org::freedesktop::Telepathy::PropertyFlags &);



#endif // header guard

